"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _rax = require("rax");

var _universalEnv = require("universal-env");

var _raxCanvas = _interopRequireDefault(require("rax-canvas"));

var _g2Mobile = _interopRequireDefault(require("g2-mobile"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

if (_universalEnv.isWeb) {
  _g2Mobile.default.Global.pixelRatio = 2;
}

var Chart =
/*#__PURE__*/
function (_Component) {
  _inherits(Chart, _Component);

  function Chart(props) {
    var _this;

    _classCallCheck(this, Chart);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Chart).call(this, props));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "setRef", function (ref) {
      _this.chartInstance = ref;
    });

    return _this;
  }

  _createClass(Chart, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var context = this.chartInstance.getContext();
      this.draw(context);
    }
  }, {
    key: "draw",
    value: function draw(context) {
      var _this$props = this.props,
          children = _this$props.children,
          data = _this$props.data,
          config = _this$props.config;
      var el = (0, _rax.findDOMNode)(this.chartInstance);

      if (!children) {
        return;
      }

      context.render();
      this.chart = new _g2Mobile.default.Chart({
        el: el,
        context: context
      });
      this.chart.source(data, config);
      this.chart.axis(false);
      this.renderChildren(context);
    }
  }, {
    key: "renderChildren",
    value: function renderChildren(context) {
      var _this2 = this;

      var children = this.props.children;

      if (children && !Array.isArray(children)) {
        children = [children];
      }

      children.forEach(function (item) {
        if (item.type && item.type.draw) {
          item.type.draw(_this2.chart, item.props);
        }
      });
      this.chart.render();
    }
  }, {
    key: "render",
    value: function render() {
      var style = this.props.style;

      var chartStyle = _objectSpread({}, style); // weex canvas must have backgroundColor


      if (_universalEnv.isWeex && !chartStyle.backgroundColor) {
        chartStyle.backgroundColor = '#ffffff';
      }

      return (0, _rax.createElement)(_raxCanvas.default, {
        style: chartStyle,
        ref: this.setRef
      });
    }
  }]);

  return Chart;
}(_rax.Component);

var _default = Chart;
exports.default = _default;
module.exports = exports["default"];